DECLARE SUB LoadLand (f$)
DECLARE SUB SaveLand (f$)
DECLARE SUB GetMouseMove (x%, y%)
DECLARE SUB ShowPartLand (lx%, x%)
DECLARE SUB ShowRadar (lx%)
DECLARE SUB ShowLand (lx%)
DECLARE SUB SetMouseRange (l%, t%, r%, b%)
DECLARE SUB HideMouse ()
DECLARE SUB SetMousePos (x%, y%)
DECLARE SUB SetGraphCursor (xh%, yh%, pels%())
DECLARE SUB ShowMouse ()
DECLARE SUB MouseStatus (state%, x%, y%)
DECLARE FUNCTION InitMouse% ()
DEFINT A-Z
DIM SHARED land(0 TO 2999) AS INTEGER

'SOPWITH II Editor, created by Andrew Durdin <andy@tavultesoft.com>

'$INCLUDE: 'QB.BI'

LoadLand "sopwith2.exe"

SCREEN 7, , 0, 0
CLS

IF (InitMouse = 0) THEN
	SCREEN 0, 0, 0: WIDTH 80
	PRINT "Unable to initialize mouse"
	SYSTEM
END IF

landx = 100

ShowMouse
ShowLand landx

mbdown = 0
DO
	a$ = ""
	mb = 0
	DO WHILE a$ = ""
		a$ = INKEY$
		MouseStatus mb, mx, my
		IF mb >= 1 THEN
			a$ = CHR$(255) + CHR$(mb)
			mx = mx \ 2
			mbdown = mb
		ELSE
			mbdown = 0
		END IF
	LOOP
	SELECT CASE a$
		CASE CHR$(27)
			EXIT DO
		CASE CHR$(255) + CHR$(1)'left
			IF mx >= 169 AND my >= 182 THEN
				'Set land position
				lx = (mx - 169) * 20 - 160
				landx = lx
				ShowLand landx
			END IF
			IF my < 180 THEN
				land(landx + mx) = 199 - my
				ShowLand landx
			END IF
		CASE CHR$(255) + CHR$(2)'right
		CASE CHR$(255) + CHR$(3)'both
		CASE CHR$(0) + CHR$(58 + 2)' save
			LOCATE 25, 1
			INPUT ; a$
			IF LEN(a$) > 8 THEN a$ = LEFT$(a$, 8)
			SHELL "copy sopwith2.exe " + a$ + ".exe"
			LOCATE 25, 1
			PRINT "        ";
			SaveLand a$ + ".exe"
			CLS
			ShowLand landx
		CASE CHR$(0) + CHR$(58 + 3)'load
			LOCATE 25, 1
			INPUT ; a$
			IF LEN(a$) > 8 THEN a$ = LEFT$(a$, 8)
			LoadLand a$ + ".exe"
			CLS
			ShowLand landx
	END SELECT
LOOP

WHILE INKEY$ = "": WEND

SUB GetMouseDown (btn, state, x, y, n)
	DIM mregs AS RegType
	mregs.ax = &H5
	mregs.bx = btn \ 2
	CALL Interrupt(&H33, mregs, mregs)
	state = mregs.ax
	x = mregs.cx
	y = mregs.dx
	n = mregs.bx
END SUB

SUB GetMouseMove (x, y)
	DIM mregs AS RegType
	mregs.ax = &HB
	CALL Interrupt(&H33, mregs, mregs)
	x = mregs.cx
	y = mregs.dx
END SUB

SUB GetMouseUp (btn, state, x, y, n)
	DIM mregs AS RegType
	mregs.ax = &H6
	mregs.bx = btn \ 2
	CALL Interrupt(&H33, mregs, mregs)
	state = mregs.ax
	x = mregs.cx
	y = mregs.dx
	n = mregs.bx
END SUB

SUB HideMouse
	DIM mregs AS RegType
	mregs.ax = &H2
	CALL Interrupt(&H33, mregs, mregs)
END SUB

FUNCTION InitMouse
	DIM mregs AS RegType
	mregs.ax = &H0
	CALL Interrupt(&H33, mregs, mregs)
	InitMouse = mregs.ax
END FUNCTION

SUB LoadLand (f$)
	'things begin at &HBBA1& + 1&
   
	t$ = " "
	OPEN f$ FOR BINARY ACCESS READ AS #1
	SEEK #1, &HA643& + 1
	FOR i = 0 TO 2999
		GET #1, , t$
		land(i) = ASC(t$)
	NEXT
	CLOSE #1
END SUB

SUB MouseReset
	DIM mregs AS RegType
	mregs.ax = &H21
	CALL Interrupt(&H33, mregs, mregs)
END SUB

SUB MouseStatus (state, x, y)
	DIM mregs AS RegType
	mregs.ax = &H3
	CALL Interrupt(&H33, mregs, mregs)
	state = mregs.bx
	x = mregs.cx
	y = mregs.dx
END SUB

SUB SaveLand (f$)
	SHELL "copy sopwith2.exe" + f$ + ".exe"
	OPEN f$ FOR BINARY ACCESS WRITE AS #1
	SEEK #1, &HA643& + 1
	FOR i = 0 TO 2999
		t$ = CHR$(land(i))
		PUT #1, , t$
	NEXT
	CLOSE #1
END SUB

SUB SetGraphCursor (xh, yh, pels())
	DIM mregs AS RegTypeX
	mregs.ax = &H9
	mregs.bx = xh
	mregs.cx = yh
	mregs.es = VARSEG(pels(0))
	mregs.dx = VARPTR(pels(0))
	CALL INTERRUPTX(&H33, mregs, mregs)
END SUB

SUB SetMousePos (x, y)
	DIM mregs AS RegType
	mregs.ax = &H4
	mregs.cx = x
	mregs.dx = y
	CALL Interrupt(&H33, mregs, mregs)
END SUB

SUB SetMouseRange (l, t, r, b)
	DIM mregs AS RegType
	mregs.ax = &H7
	mregx.cx = l
	mregs.dx = r
	CALL Interrupt(&H33, mregs, mregs)
	mregs.ax = &H8
	mregx.cx = t
	mregs.dx = b
	CALL Interrupt(&H33, mregs, mregs)
END SUB

SUB ShowLand (lx)
	SCREEN 7, , 1, 0
	IF lx > 2680 THEN lx = 2680
	IF lx < 0 THEN lx = 0

	LINE (0, 0)-(319, 180), 0, BF
	LINE (0, 181)-(319, 181), 15
	ox = lx
	FOR x = lx TO lx + 319
		LINE (ox - lx, 199 - land(ox))-(x - lx, 199 - land(x)), 15
		ox = x
	NEXT
	'Show Radar
	LINE (169, 182)-(319, 199), 0, BF
	LINE (169, 183)-(169, 199), 15
	LINE (319, 183)-(319, 199), 15
	LINE (169, 199)-(319, 199), 15
	ox = 0: oh = 199
	FOR x = 0 TO 2999 STEP 20
		th = 0
		FOR i = 0 TO 19
			th = th + land(x + i)
		NEXT
		h = th \ 20
		IF x >= lx AND x < lx + 319 THEN
			c = 13
		ELSE
			c = 15
		END IF
		LINE (ox \ 20 + 169, 199 - oh \ 12)-(x \ 20 + 169, 199 - h \ 12), c
		ox = x: oh = h
	NEXT
   
   
	SCREEN 7, , 0, 0
	HideMouse
	PCOPY 1, 0
	ShowMouse
END SUB

SUB ShowMouse
	DIM mregs AS RegType
	mregs.ax = &H1
	CALL Interrupt(&H33, mregs, mregs)
END SUB

